<?php
/*
  Plugin Name: Blackjack
  Plugin URI: http://www.thulasidas.com/plugins/blackjack
  Description: <em>Lite Version</em>: Blackjack game. No complicated setup, no server load or submit, just a shortcode on a page!
  Version: 1.80
  Author: Manoj Thulasidas
  Author URI: http://www.thulasidas.com
 */

/*
  Copyright (C) 2008 www.ads-ez.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

if (class_exists("Blackjack")) {
  $plg = "Blackjack Lite";
  $lite = plugin_basename(__FILE__);
  include_once('ezDenyLite.php');
  ezDenyLite($plg, $lite);
}
else {

  require_once('EzOptions.php');

  class Blackjack extends EzBasePlugin {

    // var $title = "Blackjack Game", $help, $credit;
    var $options, $optionName;
    var $slug, $plgDir, $plgURL, $ezAdmin, $myPlugins;
    var $adminMsg = '';

    const shortCode = 'blackjack';

    static $gamePage;

    function Blackjack() { //constructor
      parent::__construct("blackjack", "Blackjack", __FILE__);
      $this->prefix = 'blackjack';
      $this->adminMsg = '';
      $defaultOptions = $this->mkDefaultOptions();
      $this->optionName = $this->prefix;
      $this->options = get_option($this->optionName);
      if (empty($this->options)) {
        $this->options = $defaultOptions;
      }
      else {
        $this->options = array_merge($defaultOptions, $this->options);
      }
      $this->credit = "<a href='http://buy.thulasidas.com/blackjack' target='_blank'>Blackjack</a> by <a href='http://www.Thulasidas.com/' target='_blank' title='Unreal Blog proudly brings you Blackjack'>Unreal</a>";
    }

    static function findShortCode($posts) {
      self::$gamePage = false;
      if (empty($posts)) {
        return $posts;
      }
      foreach ($posts as $post) {
        if (stripos($post->post_content, self::shortCode) !== false) {
          self::$gamePage = true;
          break;
        }
      }
      return $posts;
    }

    function blackjackStyles() {
      if (!self::$gamePage) {
        return;
      }
      if (is_admin()) {
        return;
      }
      wp_register_style('blackjackCSS', "{$this->plgURL}/blackjack.css");
      wp_enqueue_style('blackjackCSS');
    }

    function blackjackScripts() {
      if (!self::$gamePage) {
        return;
      }
      if (is_admin()) {
        return;
      }
      wp_register_script('blackjackJS', "{$this->plgURL}/blackjack.js", array("jquery"));
      wp_enqueue_script('blackjackJS');
    }

    function displayGame($atts, $content = '') {
      if (!empty($content)) {
        $this->title = $content;
      }
		$hiscore_01 = $this->options['hiscore_01'];
		$hiscore_02 = $this->options['hiscore_02'];
		$hiscore_03 = $this->options['hiscore_03'];
		$winner_01 = $this->options['winner_01'];
		$winner_02 = $this->options['winner_02'];
		$winner_03 = $this->options['winner_03'];

		
      $game = "<div id='blackjack'>
			<h2>{$this->title}</h2>
			<div class='page'>   
				<div class='dealer-cards'>
					<div class='card card1'></div>
					<div class='card flipped card2'></div>
					<div class='new-cards'></div>
					<div class='clear'></div>
					<div id='dealerTotal' class='dealer-total'></div>
				</div>
				<div class='clear'></div>
				<div class='player-cards'>
					<div class='card card1'></div>
					<div class='card card2'></div>
					<div class='new-cards'></div>
					<div class='clear'></div>
					<div id='playerTotal' class='player-total'></div>
				</div>
				<div class='buttons'>
					<div class='btn' id='hit'>Hit</div>
					<div class='btn' id='stand'>Stand</div>
				</div>
				<div class='betting-area'>
					<div>
					  <b>Ставка</b>
					</div>		
					<div id='bet' class='bet money'>0</div>
					<div>
						<div class='btn' id='more100'>+ 100</div>
						<div class='btn' style='float: left;' 	id='more'>+ 10</div>
						<div class='btn' style='float: right;' 	id='less100'>- 100</div>
						<div class='btn' style='float: right;'  id='less'>- 10</div>
					</div>
					<div class='clear'></div>
				</div>
				<div style='float: right;margin-right: 12px;margin-top: 22px;font-size: small;'>
					<ul style='text-align: left;'><b>Champions:</b>
						<li>" .$winner_01 ." (<span id='hiscore_01' class='hiscore'>" .$hiscore_01 ."</span>)</li>
						<li>" .$winner_02 ." (<span id='hiscore_02' class='hiscore'>" .$hiscore_02 ."</span>)</li>
						<li>" .$winner_03 ." (<span id='hiscore_03' class='hiscore'>" .$hiscore_03 ."</span>)</li>
					</ul>
				</div>					
				<div>
					<b>Деньги</b><br />
					<span id='money' class='money'>500</span>
					<div class='clear'></div>
				</div>
				<div class='clear'></div>
				<div id='message' class='message'></div>
				<div class='submit'>
					<form method='POST' style='padding-bottom: 12px;'>
						<input type='text' id='result' name='result' style='text-align:center;'/>
						<label id='lbl_winner'>Можно сохранить и закончить игру, или рискнуть и продолжить...</label><br />
						<input type='text' id='winner' name='winner' placeholder='Введите ваше Имя' style='text-align:center;width:30%;height: 40px;'/>
						<input type='submit' id='save_result' value='Сохранить' style='padding: 11px !important; background-color: orange;'/>					
					</form>
				</div>
			</div>
		<div>";

		if ($_POST['result']) {
			$hiscore = $_POST['result'];
			
			if ($_POST['winner']) {
				$winner = $_POST['winner'];
			} else {
				$winner = 'Прохожий';
			}
			
			if ($hiscore > $hiscore_03) {
				if ($hiscore > $hiscore_02) {
					if ($hiscore > $hiscore_01) {
						$this->options['hiscore_01'] = $hiscore;
						$this->options['winner_01'] = $winner;
						$this->options['hiscore_02'] = $hiscore_01;
						$this->options['winner_02'] = $winner_01;
						$this->options['hiscore_03'] = $hiscore_02;
						$this->options['winner_03'] = $winner_02;							
					} else {
						$this->options['hiscore_02'] = $hiscore;
						$this->options['winner_02'] = $winner;
						$this->options['hiscore_03'] = $hiscore_02;
						$this->options['winner_03'] = $winner_02;						
					}
				} else {
					$this->options['hiscore_03'] = $hiscore;
					$this->options['winner_03'] = $winner;
				}
			}
		
			update_option($this->optionName, $this->options);

			Header("Location: " .get_permalink()); //Предотвращаем повторную отправку формы
		}

      if ($this->options['showCredit']) {
        $game .= "<div style='text-align:center;font-size:x-small;'>{$this->credit}</div>\n";
      }
      return $game;
    }

    function mkDefaultOptions() {
      $options = array();
      $options['showCredit'] = false;
      $options['kill_author'] = false;
	  $options['hiscore_01'] = 0;
	  $options['hiscore_02'] = 0;
	  $options['hiscore_03'] = 0;
	  $options['winner_01'] = '- - -';
	  $options['winner_02'] = '- - -';
	  $options['winner_03'] = '- - -'; 
      return $options;
    }

    function handleSubmits() {
      if (empty($_POST)) {
        return;
      }
      if (!check_admin_referer("$this->prefix-submit", "$this->prefix-nonce")) {
        return;
      }

      if (isset($_POST['saveChanges'])) {		  
        $this->adminMsg = '<div class="updated"><p><strong>Options saved.</strong></p> </div>';
        $this->options['showCredit'] = isset($_POST['showCredit']);
        $this->options['kill_author'] = isset($_POST['kill_author']);
		if (isset($_POST['hiscore_01'])) {
			$this->options['hiscore_01'] = $_POST['hiscore_01'];
		}
		if (isset($_POST['hiscore_02'])) {
			$this->options['hiscore_02'] = $_POST['hiscore_02'];
		}
		if (isset($_POST['hiscore_03'])) {
			$this->options['hiscore_03'] = $_POST['hiscore_03'];
		}
		if (isset($_POST['winner_01'])) {
			$this->options['winner_01'] = $_POST['winner_01'];
		}
		if (isset($_POST['winner_02'])) {
			$this->options['winner_02'] = $_POST['winner_02'];
		}
		if (isset($_POST['winner_03'])) {
			$this->options['winner_03'] = $_POST['winner_03'];
		}		
        update_option($this->optionName, $this->options);
      }
    }

    function printAdminPage() {
      $ez = parent::printAdminPage();
      if (empty($ez)) {
        return;
      }
      $this->handleSubmits();
      echo $this->adminMsg;
      if ($this->options['showCredit']) {
        $showCredit = "checked='checked'";
      }
      else {
        $showCredit = "";
      }
      if ($this->options['kill_author']) {
        $kill_author = "checked='checked'";
      }
      else {
        $kill_author = "";
      }
	  if ($this->options['hiscore_01']) {	  
        $hiscore_01 = $this->options['hiscore_01'];				
      }
      else {
        $hiscore_01 = 0;	
      }
	  if ($this->options['winner_01']) {	  
        $winner_01 = $this->options['winner_01'];				
      }
      else {
        $winner_01 = '';	
      }	 
	  if ($this->options['hiscore_02']) {	  
        $hiscore_02 = $this->options['hiscore_02'];				
      }
      else {
        $hiscore_02 = 0;	
      }
	  if ($this->options['hiscore_03']) {	  
        $hiscore_03 = $this->options['hiscore_03'];				
      }
      else {
        $hiscore_03 = 0;	
      }
	  
	  if ($this->options['winner_01']) {	  
        $winner_01 = $this->options['winner_01'];				
      }
      else {
        $winner_01 = '';	
      }	
	  if ($this->options['winner_02']) {	  
        $winner_02 = $this->options['winner_02'];				
      }
      else {
        $winner_02 = '';	
      }	
	  if ($this->options['winner_03']) {	  
        $winner_03 = $this->options['winner_03'];				
      }
      else {
        $winner_03 = '';	
      }		  
	  	  
      ?>
      <div class="wrap" style="width:1000px">
        <h2><?php echo "{$this->name}{$this->strPro}"; ?><a href="http://validator.w3.org/" target="_blank"><img src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid HTML5" title="<?php echo "{$this->name}{$this->strPro}"; ?> Admin Page is certified Valid HTML5" height="31" onmouseover="Tip('<?php echo "{$this->name}{$this->strPro}"; ?> Admin Page is certified Valid HTML5, with no errors in the HTML code generated by the plugin.')" onmouseout="UnTip()" width="88" class="alignright"/></a>
        </h2>
        <br>
        <form method="post">

          <?php $this->renderNonce(); ?>

          <table style="width:95%">
            <tr><td style="width:40%">
                <!--  Help Info here -->
                <ul style="padding-left:10px;list-style-type:circle; list-style-position:inside;" >
                  <li>
                    <a href="#" title="Click for help" onclick="TagToTip('help0', WIDTH, 300, TITLE, 'How to Use it', STICKY, 1, CLOSEBTN, true, CLICKCLOSE, true, FIX, [this, 5, 5])">
                      How to use this plugin?
                    </a>
                  </li>
                  <li>
                    <a href="#" title="Click for help" onclick="TagToTip('help2', WIDTH, 300, TITLE, 'Color Customization', STICKY, 1, CLOSEBTN, true, CLICKCLOSE, true, FIX, [this, 5, 5])">
                      How can I change the colors?
                    </a>
                  </li>
                </ul>
              </td>
              <?php
              $ez->renderHeadText();
              ?>
            </tr>
            <tr><td colspan="3">
                <h3>Blackjack Plugin Options</h3>
				
                <label for="hiscore_01">HiScore 01: </label>
				<input type="text" id="hiscore_01" name="hiscore_01" style="text-align:center;" value=<?php echo $hiscore_01; ?> size="6"/>
				<input type="text" id="winner_01" name="winner_01" style="text-align:center;" value="<?php echo $winner_01; ?>" size="20"/>
                <br />
                <label for="hiscore_02">HiScore 02: </label>
				<input type="text" id="hiscore_02" name="hiscore_02" style="text-align:center;" value=<?php echo $hiscore_02; ?> size="6"/>
				<input type="text" id="winner_02" name="winner_02" style="text-align:center;" value="<?php echo $winner_02; ?>" size="20"/>
                <br />
                <label for="hiscore_03">HiScore 03: </label>
				<input type="text" id="hiscore_03" name="hiscore_03" style="text-align:center;" value=<?php echo $hiscore_03; ?> size="6"/>
				<input type="text" id="winner_03" name="winner_03" style="text-align:center;" value="<?php echo $winner_03; ?>" size="20"/>
                <br /><br />			
                <label for="showCredit" style="color:#e00;" onmouseover="Tip('If you would like to support this plugin development, you can show a tiny credit link below the game display.', WIDTH, 240, TITLE, '', FIX, [this, 5, 5])" onmouseout="UnTip()"><input type="checkbox" id="showCredit"  name="showCredit" <?php echo $showCredit; ?> /> &nbsp; Show a tiny credit link at the bottom of the game.</label>
                <br /><b>
                  <label for='kill_author' onmouseover="Tip('If you find the author links and ads on the plugin admin page distracting or annoying, you can suppress them by checking this box. Please remember to save your options after checking.', WIDTH, 240, TITLE, '', FIX, [this, 5, 5])" onmouseout="UnTip()">
                    <input type='checkbox' id='kill_author' name='kill_author' <?php echo $kill_author; ?> /> &nbsp; Kill author links on the admin page?
                  </label>
                </b>
              </td></tr>
          </table>
          <div class="submit">
            <input class="button button-primary" type="submit" name="saveChanges" value="Save Changes" title="Save the changes as specified above" onmouseover="Tip('Save the changes as specified above', WIDTH, 240, TITLE, 'Save Changes')" onmouseout="UnTip()"/>
          </div>
        </form>
        <hr />
        <div id="help0" style='display:none;'>
          You use the plugin with the help of a shortcode. You create a new post or page and type in just <code>[blackjack]</code>. Visit this post/page with the plugin active, and you will see the game displayed.<br>
          If you would like to change the title, use the form <code>[blackjack]Your New Title[/blackjack]</code>.
        </div>
        <div id="help2" style='display:none;'>
          [Work in Progress] In the Pro version, you will be able to tweak the colors using the color pickers.<br>
          If you prefer to stay with the Lite version, you can change the game colors by editing the style file <code>blackjack.css</code> in the plugin folder.
        </div>
        <br />
        <?php
        $ez->renderSupport();
        $ez->renderWhyPro();
        $ez->renderTailText();
        ?>
        <table>
          <tr><th scope="row">Credits</th></tr>
          <tr><td>
              <ul style="padding-left:10px;list-style-type:circle; list-style-position:inside;" >
                <li>
                  <b>Blackjack</b> is a WordPress plugin interface to the <a href="https://github.com/tonyspiro/blackjack/ " title="blackjack code page">blackjack packge by Tony Spiro</a>, which does all the heavy-lifting of rendering the game.
                </li>
                <li>
                  <b>Blackjack Pro</b> uses the excellent Javascript color picker by <a href="http://jscolor.com" target="_blank" title="Javascript color picker"> JScolor</a>.
                </li>
                <li>
                  It also uses the excellent Javascript/DHTML tooltips by <a href="http://www.walterzorn.com" target="_blank" title="Javascript, DTML Tooltips"> Walter Zorn</a>.
                </li>
              </ul>
            </td>
          </tr>
        </table>
      </div>
      <?php
    }
  }
} //End Class Blackjack

if (class_exists("Blackjack")) {
  $blackjack = new Blackjack();
  if (isset($blackjack)) {
    add_shortcode(Blackjack::shortCode, array($blackjack, 'displayGame'));
    add_action('wp_enqueue_scripts', array($blackjack, 'blackjackStyles'));
    add_action('wp_enqueue_scripts', array($blackjack, 'blackjackScripts'));
    add_filter('the_posts', array("Blackjack", "findShortCode"));
  }
}

// blackjack widget
class BlackJack_Widget extends WP_Widget {

	function __construct() {
		// Instantiate the parent object
		parent::__construct( false, 'BlackJack' );
	}

	function widget( $args, $instance ) {
		// Widget output
		extract($args);
		
		$widget_title = get_option('blackjack_widget_title');
		$widget_image = get_option('blackjack_widget_link');
		$widget_link = get_option('blackjack_widget_image');
		
		$blackjack_option = get_option('blackjack');
		$hiscore_01 = $blackjack_option['hiscore_01'];
		$hiscore_02 = $blackjack_option['hiscore_02'];
		$hiscore_03 = $blackjack_option['hiscore_03'];
		$winner_01 = $blackjack_option['winner_01'];
		$winner_02 = $blackjack_option['winner_02'];
		$winner_03 = $blackjack_option['winner_03'];		
			

		echo $before_widget; 
		echo $before_title;
		echo get_option('blackjack_widget_title'); 
		echo $after_title;
		echo "<div><ul style='text-align: left;'><b>Наши Чемпионы:</b>
						<li>" .$winner_01 ." (" .$hiscore_01 .")</li>
						<li>" .$winner_02 ." (" .$hiscore_02 .")</li>
						<li>" .$winner_03 ." (" .$hiscore_03 .")</li>
					</ul></div>";
		echo "<a target='_blank' title='Поиграем?' href='" .$widget_link ."'><img src='" .$widget_image ."'/></a>";
		echo $after_widget; 		
	}

	function update( $new_instance, $old_instance ) {
		// Save widget options
		if (!empty($_REQUEST['blackjack_widget_title'])) {
			update_option('blackjack_widget_title', $_REQUEST['blackjack_widget_title']);
		}
		if (!empty($_REQUEST['blackjack_widget_link'])) {
			update_option('blackjack_widget_link', $_REQUEST['blackjack_widget_link']);
		}
		if (!empty($_REQUEST['blackjack_widget_image'])) {
			update_option('blackjack_widget_image', $_REQUEST['blackjack_widget_image']);
		}		
	}

	function form( $instance ) {
		// Output admin widget options form
		$widget_title = get_option('blackjack_widget_title');
		$widget_image = get_option('blackjack_widget_link');
		$widget_link = get_option('blackjack_widget_image');		
		
		echo "<p><label>Title: </label><input type='text' name='blackjack_widget_title' style='width: 100%;' value='" .$widget_title ."'/></p>";
		echo "<p><label>Image: </label><input type='text' name='blackjack_widget_link' style='width: 100%;' value='" .$widget_image ."'/></p>";
		echo "<p><label>Link: </label><input type='text' name='blackjack_widget_image' style='width: 100%;' value='" .$widget_link ."'/></p>";		
	}
}

function BlackJack_register_widgets() {
	register_widget( 'BlackJack_Widget' );
}
add_action('widgets_init', 'BlackJack_register_widgets');
